/**
 * Parses HTML and returns a root element
 *
 * @param {String} html - String of HTML markup to parse into a Virtual Tree
 * @param {TransactionConfig=} options - Contains additional options
 * @return {VTree} - Parsed Virtual Tree Element
 */
export default function parse(html: string, options?: TransactionConfig | undefined): VTree;
export const openComment: RegExp;
export const closeComment: RegExp;
export const openTag: RegExp;
export const closeTag: RegExp;
export const attribute: RegExp;
export const parseAttr: RegExp;
export const text: RegExp;
export type TransactionConfig = import('./types').TransactionConfig;
export type ParserConfig = import('./types').ParserConfig;
export type VTree = import('./types').VTree;
